// LISTION.c  made from  digion & getfile (==> list ionograms).
// List all bytes in each ionogram header, check sizes etc.  Day=0 runs to 31.
typedef unsigned char   byte;
struct  filhead  {           //Header at the beginning of each file, on disk..
    int    fnum;                         // Total Number of ionograms in file.
    long   fsize;                                 // Total file size, in bytes
    byte   fsite, fofset;                         //Station: 0,1=Ackld, 2=Chch
    int    fyear;                                 //Year (not stored w ionogs)
    byte   fmon, fday;                            //Date file is last modified
    byte   fhour, fmin, fsec;                     //Time of last modification.
    byte   fflags;  };
struct  ionhead {            //Header for each stored ionogram................
    byte  n1,n2,  l1,l2, r1,r2;                   //Two-byte inum, lcol, rcol.
    byte  h1,h2,  s1,s2;                 //2-byte ht, size(blocks of 16 bytes)
    byte  mon,day, hr,min,sec;         //Date, time that ionogram was recorded
    byte  flg; };                                 //Various flags, see iono.h
#include  <stdio.h>
#include  <conio.h>
#include  <stdlib.h>
#include  <string.h>
#define HSIZE	  16	                              //Size of header structs
#define LHSIZE	  16L	                              // & in double precision
struct filhead fp;
struct ionhead ip;
FILE *ptr;   long off;
int   i, ntotl, inum, size, dayn, lnum, show= 1;
char  c, *dname, datfile[30], drive[3],dir[66],name[9],ext[5];
void  main(int argc, char *argv[])
{ printf(" LISTION [mmmyy.dd] lists ionog headers.  [mmmyy=>all Days, esc=>stop]");
      if   (argc==2) strcpy(datfile, argv[1]);
      else { printf("\nEnter file name to analyse: "); scanf("%s",datfile); }
RUN: if (strlen(datfile) < 2)   exit(0);
     fnsplit(datfile, drive,dir,name,ext);
     ext[0]= *" ";   if ((dayn=atoi(ext))==0) { show =-1; goto NXT; }//do month
 	    if (access(datfile, 4) < 0)
		  {	printf("\nCan't access file %s ", datfile);   goto NXT; }
	    if ( (ptr= fopen(datfile, "r+b") ) == 0 )
		  { printf("\nCan't open file %s  ",  datfile);   goto NXT; }
	    if ( fread(&fp,HSIZE,1,ptr) != 1)
		  { printf("\nCan't read Header for %s",datfile); goto NXT; }
	    if ( (ntotl= fp.fnum) == 0 )  {  fclose( ptr );
			printf( "\nFile %s is empty.",  datfile );    goto NXT; }
    printf("\n File= %s  for %d/%d/%d,  Site# %d. %5d Ionograms:\t\tHeader@",
        datfile, fp.fday,fp.fmon,fp.fyear, fp.fsite, ntotl);   if (show>0)
 printf("\n  inum:    lcol:   rcol:   nhits:   size/16  mon-day   hr-min-sec flgs  #Block#");
	off = LHSIZE;  inum= 0;
 for ( i = 1; i <= ntotl; i++ )
 {    if ( fseek(ptr, off, 0) != 0 )  { printf("\n#Data ends."); goto NXT; }
	  if (fread(&ip,HSIZE,1,ptr)!=1)  { printf("\n#No Header."); goto NXT; }
      lnum=inum; inum=ip.n1+ip.n2*256; size=ip.s1+ip.s2*256;    //old #, size
  if (show>0)  {   printf("\n%3d,%3d%5d,%3d", ip.n1,ip.n2, ip.l1,ip.l2);
    printf("%4d,%3d%5d,%3d %5d,%3d",ip.r1,ip.r2, ip.h1,ip.h2, ip.s1,ip.s2);
    printf("%5d%4d %4d%4d%4d ",     ip.mon,ip.day, ip.hr,ip.min,ip.sec);
    printf("%4d  #%6u", ip.flg, off>>4);
    if (i%20==0) { if(getch()==27)  show= 0;        //pause, head at 20 lines
printf("\n  inum:    lcol:   rcol:   nhits:   size/16  mon-day   hr-min-sec flgs  #Block#");}}
  else if (max(inum,1)!=lnum+1 || ip.s2>3 || ip.mon>12 || ip.l2!=0)    {
       printf("\n##> Error at i,inum,lnum=%4d,%4d,%4d : s2,mon,l2%4d%4d%4d",
                        i,inum,lnum, ip.s2,ip.mon,ip.l2);  goto NXT;   }
    off += ((long)size <<4) + LHSIZE;                         //step over data
 }
    printf(" %3d O.K. ", inum);  if(inum!=ntotl) printf("??");
NXT: itoa(101+dayn,ext,10); ext[0]=*"."; fnmerge(datfile,drive,dir,name,ext);
     if(show>=0) { printf("  Next Day ? ");  if(getch()!=13) exit(0); }
     fclose( ptr );   if (dayn<31) goto RUN;                     //do next day
}//end Main.
