// FIXION.c  (from ListIon),  to Find valid file headers,  and write New File.
//20.8.97:- ion# check (!=last, & <1540) stops newfile changing when re-fixed.
//Still get sections with all-good headers, but garbled ionogs (eg Feb93.05,9)
#include <stdio.h>                                               //JET 7-8/97.
#include <conio.h>          //Arg1= filename;  Arg2= # of ionogs to pass over.
#include <stdlib.h>                          // " -ve to fix & write new file.
#include <string.h>       //Fixion mmmyy - Checks whole month, at 2-3 sec/day.
#include <dir.h>
typedef unsigned char byte;
struct filhead {                       //Header at start of each file, on disk
   int  fnum;  long  fsize;                        //#Ionogs; File size(bytes)
   byte fsite, fofset;                             //Station: 0,1=Ackld,2=Chch
   int  fyear;                                     //Year(not stored w ionogs)
   byte fmon,fday, fhour,fmin,fsec, flg; };        //Time of last modification
struct filhead fp;
FILE *ptr, *pth, *pto, *ptx;                  //==>filin,header,filout,scanfix
byte lhr=0, zmon,zdy,zhr=0,zmin=0, zflg=9;               //z.. = header checks
byte Fl,dy, ip[15], ib[47];   long posn;      //head,seek buffers; header posn
int  i,j,k, p, day=0, badin=0, zht=64,  zyr;
int  out=0, nexhed, size=0, blocks=0;                    //block= #(16-B) read
int  inum,lnum=-1, snum=20, ntotl, tnum=0, tnew=0;
char datfile[30],  newfile[15]="n";
char drive[3], dir[66], name[9], ext[5];
char *month[]= { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
void list(byte *ip, int k);

void main(int argc, char *argv[])/////////////////////////////////////////////
{ printf("\n\t\"FIXION mmmyy.dd snum\":-  READS  Digion file, to  |snum|.");
  printf("\n\t   Then seeks for further Headers.  snum= 0 to check all.");
  printf("\n\t      snum  Negative, to  WRITE  New file=  Nmmmyy.dd.");
  printf("\n\t     \"FixIon mmmyy.dd -1\" will fix all data & headers.");
  printf("\n\t     \"FixIon mmmyy\" checks all month, ==> ScanFix.txt.");
  strcpy(datfile, argv[1]);          if (strlen(datfile)<2) exit(0);
  if (argc>1) snum= atoi(argv[2]);   fnsplit(datfile, drive,dir,name,ext);
  if (strlen(ext)<3)
  {  day= 101;    itoa(day, ext,10);    ext[0] =*".";        //Scan full month
     strcat(datfile,ext);   ptx= fopen("ScanFix.txt","at");     //O/P=>ScanFix
     fprintf(ptx, "\n\t    SCANFIX:  FixIon run for month %s.", name);  }
  if (snum<0) {  out=1;  snum=-snum;  strcat(strcat(newfile,name),ext);
                 if (!day) printf("==> %s.",newfile);     }   //Corrected File
  j= 0;  if (name[0]==*"n") j= 1;
  for (i=0; i<12; i++)
    { if (strncmpi(month[i], &name[j], 3) ==0)  zmon= i+1; }    //get month, &
  zyr= 1900+atoi(&name[3+j]);   zdy= atoi(&ext[1]);       //day from file name
  ptr= fopen(datfile, "rb");
    if (ptr==0) {  printf("\nCan't open file %s", datfile);          //NO FILE
                           if (day) goto END;     exit(1);   }
NXDAY:  zht=64;  lhr= 0;  zflg= 9;  zmin= 0;                        //to check
  fread (&fp,16,1,ptr);   ntotl= fp.fnum;                    //get file header
 printf("\n  File= %s  of %d/%d/%d,  Site# %d. %5d Ionograms.       \tHeader:",
                    datfile, fp.fday,fp.fmon,fp.fyear, fp.fsite,ntotl);
  if (!day) list(ip,99);                                           //head list
  if (fp.fyear!=zyr ||fp.fmon!=zmon ||fp.fday<zdy ||fp.fday>zdy+1)
  {  printf("\n\t##### Expect Yr,Mn,Dy=%d,%d,%d;  Header=> %d,%d,%d.\n",
               zyr,zmon,zdy, fp.fyear,fp.fmon,fp.fday);      //Bad File Header
     fp.fyear= zyr;   fp.fmon = zmon;                        //=> correct date
     fp.fday = zdy;   fp.fsite= 1;                           //ionogram checks
     fp.fofset= 0;    fp.flg= zflg;   badin= 1;
     if(out==0 &&!day) if(getch()==27) exit(1);      }       //bad; esc to end
  if (day) goto NXD;                                         //scanning month:
  if (out)   { pto= fopen(newfile, "wb");  fwrite(&fp,16,1,pto); }
  if (badin) { tnew+=1;  goto NXT; }
  for (i= 1; i<=max(snum,1); i++)
  {  if (fread(&ip,16,1,ptr) !=1)    /////////////////////////////READ HEADERS
        { printf("\n##File Ends");  exit(1); }
     blocks+=1;    tnum += 1;                                          //count
     if (out) fwrite(&ip,16,1,pto);                                     //copy
     size= ip[8] + ip[9]*256;      list(ip,0);                          //list
     for (j=1; j<=size; j++)
     {  fread(&ib[16],16,1,ptr);   blocks+=1;     //////////read 'size' blocks
        if(out) fwrite(&ib[16], 16,1,pto);   }                   //count, copy
  }//////////////////END INITIAL LIST, OF KNOWN GOOD IONOGRAMS////////////////
     zht=ip[6]; lhr=ip[12]; zflg=ip[15]&207; zmin=ip[13];  //ion header checks
NXD: nexhed= blocks+2;                                   //Flg= 9 or 57, ==> 9
NXT: if(!day) printf
       (" %s : Seek for 10 more headers ? [esc=stop, 1= do All]",datfile);
//if(day)fprintf(ptx,"\nMnDy=%d:%d hr:min=%d:%d nh,Flg=%d,%d",zmon,zdy,lhr,zmin,zht,zflg);
     if (snum &&!day) { if ( (j=getch()) ==27)  exit(0);            //esc ends
                        if (j==49) snum= 0;  list(ip,99);  }         //re-head
  for (j= 1; j<=10;)
  {  if (fread(&ib[32], 16,1,ptr)!=1)  goto END;
     for (k= 0; k<=31; k++) ///////////// MOVE DOWN 16 bytes, CHECK FOR HEADER
     {  Fl=ib[k+16];  ib[k]=Fl;                            //Fl=Flg (=9 or 57)
        inum=ib[k+1] +ib[k+2]*256;                         //ionogm sequence #
        dy=ib[k+12];  zhr=ib[k+13];                   //k=15 => head=ib[16-31]
      if (k>14 &&k<31  &&ib[k+11]==zmon &&ib[k+10]<3)      //month; size<3*256
       if ((Fl&207)==zflg &&(dy==zdy||dy==zdy+1) &&zhr<24)   //Flag, day, hour
        if (ib[k+8]==0 &&((i=ib[k+7])==zht||i==zht/2))       //# heights:hi,lo
         if(ib[k+6]==2 &&ib[k+4]<2 &&inum!=lnum &&inum<4444)  //rcol,lcol,#ion
         {  fseek(ptr, k-15-32, 1); /////////////////// HEADER FOUND; TO START
            fread(&ib, 16,3, ptr);     blocks+=1;         //Header in ib[0-15]
            if (zhr <lhr &&  zhr !=0 )   { k=0;  break; }          //hour decr
            if (zhr==lhr && ib[13]<zmin) { k=0;  break; }          //mins decr
            if(!day) list(ib, k-15);      tnum +=1;       //show,count headers
            if(blocks!=nexhed ||k!=15)    tnew +=1;             //count breaks
            lnum= inum;   lhr=zhr;   zmin= ib[13];       //for sequence checks
            size= ib[9]*256+ib[8];   nexhed= blocks+size+1;
            posn= ftell(ptr);   if (snum) j +=1;   //save posn; loop at snum>0
            if (out)
            {  fwrite(&ib, 16,3,pto);              //OUTPUT: Header==>NewIon..
               for (i=3; i<=size; i++)                //Data: copy to O/P:-...
               {  p= fread(&ip,16,1,ptr);                        //read data..
                  fwrite(&ip, 16,1, pto);   }         //copy data(even at EOF)
               fseek(ptr, posn, 0);                              //reset input
               if (p!=1) { printf("##EOF"); goto END; }
            }
         } ///////////end IF block
     }  blocks+= 1;///////////////////////// END HEADER PROCESSING
  }  goto NXT;//////found 10 headers; loop?
END: if(!day) list(ip,99);                                         //head data
    printf("\n\t##FILE ENDS:  %s  has %d Valid ionogs [from %d]",
                                  datfile, tnum, ntotl);
    if (tnew)  printf(" -- %d breaks.", tnew);
    if (day) { fprintf(ptx, "\n%s has %d Valid ionogs [from %d]",
                       datfile, tnum, ntotl);    j=day;   //j to count NoFiles
               if (tnew) fprintf(ptx," -- %d breaks.",tnew);
                else if(tnum&&tnum==ntotl) fprintf(ptx," --O.K.");
               if (badin) fprintf(ptx, " Bad File Header");
NEXDAY:        fclose(ptr);   if(day>130) exit(0);                //close, end
               day+=1;  itoa(day,ext,10);  ext[0]=*".";           //=>next day
               fnmerge(datfile, drive,dir,name,ext);              // next file
               if ( (ptr=fopen(datfile,"rb"))==0)
               {  if ((day-j)%7==1)  fprintf(ptx, "\nNo File:");
                  fprintf(ptx," %s;",datfile);  goto NEXDAY;   }
               tnum=0;  tnew=0;  badin=0;  blocks=0;
               zdy= day-100;     goto NXDAY;
             }
    if (out) { fseek(pto, 0, 0);   fp.fnum= tnum;              //# good ionogs
               fwrite(&fp, 16, 1, pto);
               printf("\n\t##Saved to File: %s.", newfile);
               fclose(ptr);  fclose(pto);  fclose(ptx);  }
    exit(0);
}//////////////-END  MAIN-////////////////////////////////////////////////////

void list(byte *ip, int k)/////////////////LIST HEADER VALUES. [K=99 to label]
{ if (k==99) { printf("\n  inum:    lcol:   rcol:   nhits:  ");
               printf("size/16  mon-day   hr-min-sec flgs ##Blocks:"); }
  else { printf("\n%3d,%3d%5d,%3d", ip[0],ip[1],  ip[2],ip[3], ip[4],ip[5]);
     printf("%4d,%3d%5d,%3d%5d,%3d",ip[4],ip[5],  ip[6],ip[7], ip[8],ip[9]);
     printf("%5d%4d %4d%4d%4d ",   ip[10],ip[11], ip[12],ip[13],ip[14]);
     printf(   "%4d #%5u+%2d",     ip[15], blocks, k);        }
}///////////////END  LIST.
